/**********************************************************************
** Copyright (C) 2000-2002 Trolltech AS.  All rights reserved.
**
** This file is part of the Qtopia Environment.
**
** This file may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
** See http://www.trolltech.com/gpl/ for GPL licensing information.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.
**
**********************************************************************/
#ifndef __LAUNCHER_CLOCK_H__
#define __LAUNCHER_CLOCK_H__


#include <qlabel.h>
#include <qdatetime.h>
#include <qpopupmenu.h>
#include <qdialog.h>
#include <qfontdatabase.h>
#include <qfont.h>

class LauncherClock : public QLabel
{
    Q_OBJECT
public:
    LauncherClock( QWidget *parent );

protected slots:
    void updateTime( void );
    void slotClockChanged( bool pm );

    void slotShowTimeSetting();
    void slotShowSetting();
    void loadConfig();
    void saveConfig();

protected:
    void mouseReleaseEvent( QMouseEvent * );
    void timerEvent( QTimerEvent * );
    void changeTime( void );
    void refreshApplet(void);
    bool ampmFormat;
    int timerId;

	QPopupMenu* menu;
	bool mDayEnable,mYearView,mYearFull,mWeekView,mWeekJapan,mWordWrap,mSecView,mYearEto; 
	QString mFontName;
	int mFontSize,mFontColor_R,mFontColor_G,mFontColor_B;

};

class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QComboBox;
class QSpinBox;
class OptionDialog : public QDialog
{
    Q_OBJECT

	public:
		OptionDialog( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
		~OptionDialog();

		void setFontName( QString family_name );
		void setFontSize( int num );
		void setDayEnable( bool flg );
		void setYearView( bool flg );
		void setYearFull( bool flg );
		void setWeekView( bool flg );
		void setWeekJapan( bool flg );
		void setWordWrap( bool flg );
		void setSecView( bool flg );
		void setFontColor_R( int num );
		void setFontColor_G( int num );
		void setFontColor_B( int num );
		void setYearEto( bool flg );

		QString getFontName();
		int getFontSize();
		bool getDayEnable();
		bool getYearView();
		bool getYearFull();
		bool getWeekView();
		bool getWeekJapan();
		bool getWordWrap();
		bool getSecView();
		int getFontColor_R();
		int getFontColor_G();
		int getFontColor_B();
		bool getYearEto();

	private:
		QFont currentFont;
		QComboBox* FontName;
		QComboBox* FontSize;
		QComboBox* DayEnable;
		QComboBox* YearView;
		QComboBox* YearFull;
		QComboBox* WeekView;
		QComboBox* WeekJapan;
		QComboBox* WordWrap;
		QComboBox* SecView;
		QSpinBox* FontColor_R;
		QSpinBox* FontColor_G;
		QSpinBox* FontColor_B;
		QComboBox* YearEto;

	protected slots:
		void accept();
	    virtual void updateSizes(); 

protected:
    QVBoxLayout* OptionLayout;
    QHBoxLayout* ColorLayout;
    QFrame* DayFrame;
    QGridLayout* FontSetting;
    QGridLayout* DaySetting;


};


#endif // __LAUNCHER_CLOCK_H__
